'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _rcTweenOne = require('rc-tween-one');

var _animTypesIconFont = require('./animTypesIconFont');

var _animTypesIconFont2 = _interopRequireDefault(_animTypesIconFont);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var keysNumber = 0;

var IconFontAnim = function (_Component) {
  _inherits(IconFontAnim, _Component);

  function IconFontAnim() {
    _classCallCheck(this, IconFontAnim);

    var _this = _possibleConstructorReturn(this, _Component.apply(this, arguments));

    ['getTweenType', 'getAnimType', 'getChildren', 'getChildrenToRender'].forEach(function (method) {
      return _this[method] = _this[method].bind(_this);
    });
    _this.onApper = false;
    _this.getAnimType(_this.props);
    var children = _this.getChildren(_this.props);
    _this.state = {
      children: children
    };
    return _this;
  }

  IconFontAnim.prototype.componentDidMount = function componentDidMount() {
    this.onApper = true;
  };

  IconFontAnim.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.type !== this.props.type) {
      this.getAnimType(nextProps);
      var children = this.getChildren(nextProps);
      this.setState({ children: children });
    }
  };

  IconFontAnim.prototype.getChildren = function getChildren(props) {
    var style = {};
    if (typeof this.type[0] === 'string' && this.type[0].indexOf('3d') && this.type[0].indexOf('rotate') === 0) {
      style.transform = 'perspective(200px)';
    }
    var key = this.newKeys();
    return props.type ? _react2["default"].createElement(_icon2["default"], { type: props.type, style: style, key: key }) : null;
  };

  IconFontAnim.prototype.getTweenType = function getTweenType(type, typeName) {
    return (_animTypesIconFont2["default"][type] || type)[typeName];
  };

  IconFontAnim.prototype.getAnimType = function getAnimType(props) {
    this.type = (0, _util.transformArguments)(props.animType);
    this.toEnter = !this.onApper ? this.getTweenType(this.type, 'appear') || this.getTweenType(this.type, 'enter') : this.getTweenType(this.type, 'enter');
    this.toLeave = this.getTweenType(this.type, 'leave');
  };

  IconFontAnim.prototype.getChildrenToRender = function getChildrenToRender() {
    var props = _extends({}, this.props);
    return _react2["default"].createElement(
      _rcTweenOne.TweenOneGroup,
      _extends({
        appear: this.props.appear,
        enter: this.toEnter,
        leave: this.toLeave
      }, props),
      this.state.children
    );
  };

  IconFontAnim.prototype.newKeys = function newKeys() {
    var key = Date.now() + '-' + keysNumber;
    keysNumber++;
    return key;
  };

  IconFontAnim.prototype.render = function render() {
    var childrenToRender = this.getChildrenToRender();
    return childrenToRender;
  };

  return IconFontAnim;
}(_react.Component);

IconFontAnim.propTypes = {
  className: _react.PropTypes.string,
  component: _react.PropTypes.any,
  children: _react.PropTypes.any,
  style: _react.PropTypes.object,
  type: _react.PropTypes.string,
  animType: _react.PropTypes.any,
  appear: _react.PropTypes.bool
};

IconFontAnim.defaultProps = {
  component: 'div',
  animType: 'leftToRight',
  appear: true
};
exports["default"] = IconFontAnim;
module.exports = exports['default'];