'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcTweenOne = require('rc-tween-one');

var _rcTweenOne2 = _interopRequireDefault(_rcTweenOne);

var _SvgMorphPlugin = require('rc-tween-one/lib/plugin/SvgMorphPlugin');

var _SvgMorphPlugin2 = _interopRequireDefault(_SvgMorphPlugin);

var _SvgDrawPlugin = require('rc-tween-one/lib/plugin/SvgDrawPlugin');

var _SvgDrawPlugin2 = _interopRequireDefault(_SvgDrawPlugin);

var _svg = require('./svg');

var _svg2 = _interopRequireDefault(_svg);

var _animTypeSVG = require('./animTypeSVG');

var _animTypeSVG2 = _interopRequireDefault(_animTypeSVG);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

_rcTweenOne2["default"].plugins.push(_SvgMorphPlugin2["default"]);
_rcTweenOne2["default"].plugins.push(_SvgDrawPlugin2["default"]);

var IconSVGAnim = function (_Component) {
  _inherits(IconSVGAnim, _Component);

  function IconSVGAnim() {
    _classCallCheck(this, IconSVGAnim);

    var _this = _possibleConstructorReturn(this, _Component.apply(this, arguments));

    ['getStartChildren', 'changeProps'].forEach(function (method) {
      return _this[method] = _this[method].bind(_this);
    });
    var children = _this.getStartChildren(_this.props);
    _this.state = {
      children: children
    };
    return _this;
  }

  IconSVGAnim.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.type !== this.props.type) {
      var type = this.props.type + 'to' + nextProps.type;
      this.changeProps(nextProps, _svg2["default"][nextProps.type], type);
      return;
    }
    var currentChildren = (0, _util.toArrayChildren)(this.props.children);
    var newChildren = (0, _util.toArrayChildren)(nextProps.children);
    var childrenDiffer = currentChildren.length !== newChildren.length;
    if (!childrenDiffer) {
      (0, _util.toArrayChildren)(currentChildren).forEach(function (item, i) {
        var newItem = newChildren[i];
        if (item.key !== newItem.key) {
          childrenDiffer = true;
        }
      });
    }
    if (childrenDiffer) {
      this.changeProps(nextProps, newChildren);
    }
  };

  IconSVGAnim.prototype.getStartChildren = function getStartChildren(props) {
    var _this2 = this;

    var svg = props.children || _svg2["default"][props.type];
    return (0, _util.toArrayChildren)(svg).map(function (item, i) {
      if (_this2.props.appear) {
        var animation = _animTypeSVG2["default"].scale;
        if (props.animation && props.animation[i]) {
          animation = props.animation[i];
        } else if (!_animTypeSVG2["default"][props.type]) {
          animation = _extends({}, animation, { delay: i * 100 });
        }
        return _react2["default"].createElement(_rcTweenOne2["default"], _extends({}, _this2.allToPath(item), {
          animation: animation,
          component: 'path',
          key: item.key || i,
          attr: 'attr'
        }));
      }
      return _react2["default"].cloneElement(item, { key: item.key || i });
    });
  };

  IconSVGAnim.prototype.allToPath = function allToPath(item) {
    var props = _extends({}, item.props);
    if (typeof item.type !== 'string') {
      throw new Error('svg tag error.');
    }
    var name = item.type.toUpperCase();
    var cx = void 0;
    var cy = void 0;
    var rx = void 0;
    var ry = void 0;
    switch (name) {
      case 'CIRCLE':
        {
          cx = parseFloat(props.cx);
          cy = parseFloat(props.cy);
          var r = parseFloat(props.r);
          delete props.cx;
          delete props.cy;
          delete props.r;
          return _extends({}, props, {
            d: 'M' + (cx - r) + ',' + cy + ' a' + r + ',' + r + ' 0 1,0 ' + r * 2 + ',0a' + r + ',' + r + ' 0 1,0 ' + -r * 2 + ',0z'
          });
        }
      case 'ELLIPSE':
        {
          cx = parseFloat(props.cx);
          cy = parseFloat(props.cy);
          rx = parseFloat(props.rx);
          ry = parseFloat(props.ry);
          delete props.cx;
          delete props.cy;
          delete props.rx;
          delete props.ry;
          return _extends({}, props, {
            d: 'M' + (cx - rx) + ',' + cy + 'a' + rx + ',' + ry + ' 0 1,0 ' + rx * 2 + ',0a' + rx + ',' + ry + ' 0 1,0 ' + -rx * 2 + ',0z'
          });
        }
      case 'RECT':
        {
          var x = parseFloat(props.x);
          var y = parseFloat(props.y);
          var w = parseFloat(props.width);
          var h = parseFloat(props.height);
          rx = parseFloat(props.rx);
          ry = parseFloat(props.ry);
          delete props.x;
          delete props.y;
          delete props.width;
          delete props.height;
          delete props.rx;
          delete props.ry;
          if (!rx && !ry) {
            return { d: 'M' + x + ',' + y + 'l' + w + ',0l0,' + h + 'l' + -w + ',0z' };
          }
          return _extends({}, props, {
            d: 'M' + (x + rx) + ',' + y + '\nl' + (w - rx * 2) + ',0\na' + rx + ',' + ry + ' 0 0,1 ' + rx + ',' + ry + '\nl0,' + (h - ry * 2) + '\na' + rx + ',' + ry + ' 0 0,1 ' + -rx + ',' + ry + '\nl' + (rx * 2 - w) + ',0\na' + rx + ',' + ry + ' 0 0,1 ' + -rx + ',' + -ry + '\nl0,' + (ry * 2 - h) + '\na' + rx + ',' + ry + ' 0 0,1 ' + rx + ',' + -ry + 'z'
          });
        }
      case 'POLYGON':
        {
          var points = parseFloat(props.points);
          delete props.points;
          var p = points.split(/\s+/);
          var path = '';
          for (var i = 0; i < p.length; i++) {
            path += (i && 'L' || 'M') + p[i];
          }
          return _extends({}, props, { d: path + 'z' });
        }
      case 'LINE':
        {
          var x1 = parseFloat(props.x1);
          var x2 = parseFloat(props.x2);
          var y1 = parseFloat(props.y1);
          var y2 = parseFloat(props.y2);
          delete props.x1;
          delete props.x2;
          delete props.y1;
          delete props.y2;
          return _extends({}, props, { d: 'M' + x1 + ',' + y1 + 'L' + x2 + ',' + y2 + 'z' });
        }
      default:
        {
          return _extends({}, props);
        }
    }
  };

  IconSVGAnim.prototype.tweenEndRemove = function tweenEndRemove(key) {
    var children = this.state.children.map(function (item) {
      if (!item) {
        return null;
      }
      if (parseFloat(item.key) !== key) {
        return item;
      }
      return null;
    }).filter(function (item) {
      return item;
    });
    this.setState({
      children: children
    });
  };

  IconSVGAnim.prototype.changeProps = function changeProps(nextProps, newChild, type) {
    var _this3 = this;

    var currentChildren = this.state.children;
    var newChildren = newChild.map(function (item) {
      return _react2["default"].createElement('path', _extends({}, _this3.allToPath(item)));
    });
    var children = [];
    currentChildren.forEach(function (item, i) {
      var d = item.props.animation ? item.props.animation.d || item.props.d : item.props.d;
      var itemProps = _extends({}, item.props);
      var toChildren = newChildren[i];
      var toChildrenProps = _extends({}, toChildren ? toChildren.props : {});
      var animation = {
        style: { scale: 0, opacity: 0 }
      };
      if (nextProps.animation && nextProps.animation[i]) {
        animation = nextProps.animation[i];
      } else if (_animTypeSVG2["default"][type]) {
        animation = _animTypeSVG2["default"][type][i];
      } else if (toChildren) {
        animation = {
          d: toChildrenProps.d
        };
      }
      if (!toChildren) {
        animation.onComplete = _this3.tweenEndRemove.bind(_this3, i);
      }
      children.push(_react2["default"].createElement(_rcTweenOne2["default"], _extends({}, toChildren ? {} : itemProps, toChildrenProps, {
        component: 'path', attr: 'attr', animation: animation, d: d, key: i
      })));
    });
    // 多出的再行插入
    if (newChildren.length > currentChildren.length) {
      newChildren.forEach(function (item, i) {
        if (i >= currentChildren.length) {
          var _a = _extends({}, _animTypeSVG2["default"].scale);
          if (nextProps.animation && nextProps.animation[i]) {
            _a = nextProps.animation[i];
          } else if (_animTypeSVG2["default"][type]) {
            _a = _animTypeSVG2["default"][type][i];
          } else {
            _a.delay = (i - currentChildren.length) * 100 + 100;
          }
          children.push(_react2["default"].createElement(_rcTweenOne2["default"], _extends({}, item.props, { animation: _a, key: i, attr: 'attr', component: 'path' })));
        }
      });
    }
    this.setState({ children: children });
  };

  IconSVGAnim.prototype.render = function render() {
    return _react2["default"].createElement(
      'svg',
      _extends({
        version: '1.2',
        xmlns: 'http://www.w3.org/2000/svg'
      }, this.props),
      this.state.children
    );
  };

  return IconSVGAnim;
}(_react.Component);

IconSVGAnim.propTypes = {
  children: _react.PropTypes.any,
  viewBox: _react.PropTypes.string,
  type: _react.PropTypes.any,
  animType: _react.PropTypes.string,
  appear: _react.PropTypes.bool,
  animation: _react.PropTypes.array
};

IconSVGAnim.defaultProps = {
  appear: true,
  viewBox: '0 0 1024 1024',
  width: 100,
  height: 100
};

exports["default"] = IconSVGAnim;
module.exports = exports['default'];